<?php if (!defined('BILLING_MODULE')) die("Hacking attempt!");

/**
 * GidPay
 *
 * @link         gidpay.ru
 */
class GidPay
{
    var $doc = 'https://docs.gidpay.ru';

    function Settings($config)
    {
        $html = [];

        $html[] = [
            'ID Магазина:',
            'Из настроек магазина в личном кабинете GidPay',
            '<input name="save_con[shop_id]" class="edit bk" type="text" value="' . $config['shop_id'] . '" style="width: 100%">',
        ];

        $html[] = [
            'Публичный ключ:',
			'Из настроек магазина в личном кабинете GidPay',
            '<input name="save_con[public_key]" class="edit bk" type="password" value="' . $config['public_key'] . '" style="width: 100%">',
        ];

        $html[] = [
            'Секретный ключ:',
            'Из настроек магазина в личном кабинете GidPay',
            '<input name="save_con[secret_key]" class="edit bk" type="password" value="' . $config['secret_key'] . '" style="width: 100%">',
        ];

        $html[] = [
            'IP фильтр:',
            'Список доверенных IP-адресов, наши адреса: 45.130.43.184',
            '<input name="save_con[ip_filter]" class="edit bk" type="text" value="' . $config['ip_filter'] . '" style="width: 100%">',
        ];


        return $html;
    }

    function Form($order_id, $config, $invoice, $description, $DevTools)
    {
        $amount = number_format($invoice['invoice_pay'], 2, '.', '') * 1;

        if (empty($description)) {
            $description = 'Balance ' . $invoice['invoice_user_name'];
        }

         $data = [
            'shop_id' => $config['shop_id'],
            'transaction_id' => $order_id,
            'amount' => $amount,
            'public_key' => $config['public_key'],
            'method' => 'full'
        ];
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, "https://gidpay.ru/api/pay");
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded"));
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data, '', '&'));
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $resp = json_decode(curl_exec($curl), true);
        curl_close($curl);

        if($resp['status'] == "error"){
            return $resp['error'];
        }
        
           header("Location: " . $resp['success']['url']);
    }

    function check_id($data)
    {
        return $data["order_id"];
    }

    function check_ok($data)
    {
        return 'OK';
    }

    function check_out($data, $config, $order_id)
    {
        global $_REQUEST;

        $valid_ip = false;
        $sIP = str_replace(' ', '', $config['ip_filter']);
        $array_IP = explode(',', $sIP);
        if (isset($_SERVER["HTTP_X_REAL_IP"])) {
            $cur_ip = $_SERVER["HTTP_X_REAL_IP"];
        }elseif (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) {
            $cur_ip = $_SERVER["HTTP_CF_CONNECTING_IP"];
        } else {
            $cur_ip = $_SERVER["REMOTE_ADDR"];
        }
        if (in_array($cur_ip, $array_IP)) {
            $valid_ip = true;
        }

        if (!$valid_ip) {
            return 'Error: ip_checked';
        }
		
		$signatureGen = md5($config['shop_id'].":".$_REQUEST['amount'].":".$config['secret_key'].":".$_REQUEST['order_id']);

        if ((string)$signatureGen === (string)$_REQUEST["sign"]) {
            return 200;
        } else {
            return 'Error: signature:: ' . $_REQUEST["sign"] . ' != ' . $signatureGen;
        }
    }
}

$Paysys = new GidPay;
